#include "HardwareBreakPointDetection.h"

HardwareBreakPointDetection::HardwareBreakPointDetection() {
};

// ------------------------------------------------------------------------------------------------------------

int HardwareBreakPointDetection::HwdBreakPoint() {

	CONTEXT context; // initialize CONTEXT structure

	context.ContextFlags = CONTEXT_DEBUG_REGISTERS; // set context flags accordingly to have access to the registers we need

	DWORD threadId = GetCurrentThreadId(); // obtain the identifier of the current thread

	HANDLE thread = OpenThread(THREAD_GET_CONTEXT, FALSE, threadId);
	/* obtain a handle to the current thread with

	THREAD_GET_CONTEXT access rights.
	 */

	if (thread != NULL) // if we managed to take a valid handle to the current thread
	{
		if (GetThreadContext(thread, &context)) /* since we are only interested in the Debug registers we do not have

		to suspend the examined thread. */ {

			if (context.Dr0 != 0 || context.Dr1 != 0 || context.Dr2 != 0 ||
				context.Dr3 != 0) {

				CloseHandle(thread);

				return 1; // hardware bp detected

			}

			else {

				CloseHandle(thread);

				return 0; // no hardware bp detected
			}

		}

		else {

			CloseHandle(thread);

			return-2; // if the GetThreadContext function fails
		}

	}

	return-1; // if OpenThread function failed to obtain a valid handle to the current thread

}
